
//  VilkkuvaPalloNotRunnableApplet.java  (c) Kari Laitinen

//  2005-11-18  Tiedosto luotu.
//  2006-10-19  Viimeisin muutos

//  Tm ohjelma toimii samoin kuin VilkkuvaPalloApplet.java. 
//  Tss versiossa apletti ei toteuta Runnable-rajapintaa, vaan
//  animaatiota tahdistavan sikeen luomiseksi on tehty
//  oma Thread-luokasta johdettu luokka. Tt tekniikkaa kytten
//  on mahdollista liitt aplettiin tarvittaessa useita sikeit.

import java.awt.* ;
import javax.swing.JApplet ;

class  Uudelleenmaalaajasaie  extends Thread
{
   boolean  saietta_on_suoritettava  =  true ;

   JApplet  isantaapletti ;

   long  uudelleenmaalausvali ;

   public Uudelleenmaalaajasaie( long    annettu_uudelleenmaalausvali,
                                 JApplet annettu_isantaapletti )
   {
      uudelleenmaalausvali  =  annettu_uudelleenmaalausvali ;
      isantaapletti         =  annettu_isantaapletti ;
   }

   public void run()
   {
      while ( saietta_on_suoritettava  ==  true )
      {
         System.out.print( " X" ) ;

         try
         {
            Thread.sleep( uudelleenmaalausvali ) ; 
         }
         catch ( InterruptedException  vangittu_poikkeus )
         {
            saietta_on_suoritettava  =  false ;
         }

         isantaapletti.repaint() ;
      }

      System.out.print( "\n run()-metodi loppuu " ) ;
   }
}


public class VilkkuvaPalloNotRunnableApplet extends JApplet
{
   int apletin_leveys, apletin_korkeus ;

   Thread  tahdistussaie ;

   boolean  palloa_on_naytettava  =  true ;

   public void init()
   {
      apletin_leveys   =  getSize().width ;
      apletin_korkeus  =  getSize().height ;
      System.out.print( "\n init()-metodia kutsuttu " ) ;
   }

   public void start()
   {
      System.out.print( "\n start()-metodia kutsuttu " ) ;

      if ( tahdistussaie  ==  null )
      {
         tahdistussaie  =  new  Uudelleenmaalaajasaie( 1000, this ) ;

         tahdistussaie.start() ;
      }
   }

   public void stop()
   {
      System.out.print( "\n stop()-metodi " ) ;

      if ( tahdistussaie  !=  null )
      {
         tahdistussaie.interrupt() ;

         tahdistussaie  =  null ;
      }
   }

   public void paint( Graphics graphics )
   {
      super.paint( graphics ) ;

      if ( palloa_on_naytettava  ==  true )
      {
         graphics.fillOval( apletin_leveys / 2 - 40,
                           apletin_korkeus / 2 - 40, 80, 80 ) ;

         palloa_on_naytettava  =  false ;
      }
      else
      {
         palloa_on_naytettava  =  true ;
      }

   }
}
























